<?php

$GLOBALS['CONFIG'] = array(); // this might become an object in the future
function config($key, $module='CORE', $value=null)
{
	if($value === null)
	{
		return $GLOBALS['CONFIG']["${module}.${key}"];
	}
	else
	{
		$GLOBALS['CONFIG']["${module}.${key}"] = $value;
	}
}

include('php/CONFIG.inc');
if(file_exists('/etc/murder/config.inc')) include('/etc/murder/config.inc');
if(file_exists('php/config.local.inc')) include('php/config.local.inc');

function safeGet($a, $k, $default='')
{
	if(isset($a) && is_array($a) && isset($a[$k]))
		return $a[$k];
	return $default;
}

function explodea($delimiter, $string, $limit=false)
{
	$r = 
		($limit===false?
			explode($delimiter, $string) :
			explode($delimiter, $string, $limit)
		);
	if(is_array($r)) return $r;
	else return array($r);
}

function baseUrl()
{
	$https = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] && 'off' != $_SERVER['HTTPS']);
	$port  = (($https && $_SERVER['SERVER_PORT']!=443) || (!$https && $_SERVER['SERVER_PORT']!=80)) ? ':' . $_SERVER['SERVER_PORT'] : '';
	$schema = ($https?'https':'http');
	$host = $_SERVER['SERVER_NAME'];
	return  "${schema}://${host}${port}";
}

function redirect($location)
{
	$url = baseUrl() . $location;
	header("Location: ${url}");
}

function page() { return Page::getInstance(); }

function registerp($handlers, $prefix=false)
{
	PluginStore::getInstance()->addHandlers($handlers, $prefix);
}

require_once('php/murder/mime.inc'); 
require_once('php/murder/plugin.inc'); 
require_once('php/murder/page.inc'); 
require_once('php/system/users.inc');
require_once('php/system/localuser.inc');

?>
