<?php

class PluginStore
{
	static private $instance = false;
	private $bIsInitialized = false;
	private $subhandlers = array();	# URL handlers

	private function __construct() { }

	private function init()
	{
		if($this->bIsInitialized) return;
		$this->bIsInitialized = true;
		$this->_addPlugins(config('PLUGIN_DIR').'/');
	}

	private function _addPlugins($directory)
	{
		$plugins = scandir($directory);
		if($plugins == false) return;
		foreach($plugins as $p)
		{
			if(substr($p, 0, 1) == '.') continue;
			$path = $directory.$p;
			if(is_dir($path))
			{
				include_once($path.'/murder.inc');
			}
		}
	}

	static public function getInstance()
	{
		if(!PluginStore::$instance)
		{
			PluginStore::$instance = new PluginStore();
			PluginStore::$instance->init();
		}
		return PluginStore::$instance;
	}

	public function addHandlers($handlers, $sub)
	{
		if(!$handlers || !is_array($handlers)) return;
		while(list($type, $h) = each($handlers))
		{
			$this->setURLHandler($sub, $h, $type);
		}
	}

	public function getURLHandler($sub, $acceptedTypes='*/*')
	{
		$subHandlers = safeGet($this->subhandlers, $sub);
		if(!$subHandlers || !is_array($subHandlers)) return false;
		$type = MurderMime::resolve(array_keys($subHandlers), $acceptedTypes);
		if($type)
		{
			return safeGet($subHandlers,$type);
		}
		return false;
	}

	public function setURLHandler($sub, $handler, $type)
	{
		if(!isset($this->subhandlers[$sub]))
		{
			$this->subhandlers[$sub] = array(); 
		}
		$this->subhandlers[$sub][$type] = $handler;
	}
}
