<?php

class PageRenderer
{
	public function __construct($page, $args)
	{
		
	}

	public function processRequest($page) { }

	protected function checkModification($page)
	{
		$headers = getallheaders();
		if(!$headers || !is_array($headers)) return;
		foreach($headers as $name => $value)
		{
			if(!strcasecmp($name, 'if-modified-since'))
			{
				$old = strtotime($value);
				$new = $page->getLastModified();
				if($new <= $old)
				{
					// Unmodified! drop and roll!
					$page->setStatus(304);
				}
				return;
			}
		}
	}

	public function sendHeaders($page)
	{
		$modified = $page->getLastModified(true);
		// We can try and do something smart with last modified
		if($modified) $this->checkModification($page);
		if(!MurderMime::isAccepted($page->getContentType(), $_SERVER['HTTP_ACCEPT']))
		{
			$page->setStatus(406);
		}

		header('HTTP/1.1 ' . $page->getStatusCode() . ' ' . $page->getStatusMessage());
		header('Content-type: ' . $page->getContentType() );
		if($page->getMaxAge())
		{
			header('Cache-Control: max-age=' . $page->getMaxAge());
		}
		if($page->getVary())
		{
			header('Vary: ' . $page->getVary());
		}
		if($modified)
		{
			header('Last-Modified: ' . $modified);
		}
	}

	public function startPage($page)
	{
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >
<head><title><?php echo htmlspecialchars($page->getTitle()); ?></title>
<link type="text/css" rel="stylesheet" href="/static/css/base.css" />
</head>
<body>
<?php
	}

	public function endPage($page)
	{
?>
</body></html>
<?php
	}

	public function mainContent($page)
	{

	}
}

?>
