<?php

class LocalUser
{
	protected $login;
	protected $name;
	protected $room;
	protected $workPhone;
	protected $homePhone;
	protected $other;
	protected $uid;
	protected $home;
	protected $shell;
	protected $hidden;

	protected $project = false;
	protected $plan    = false;
	protected $pgpkey  = false;

	protected $self    = array();
	public function __construct($line)
	{
		$fields = explode(':', $line);
		$comments	= explode(',',$fields[4]);
		$this->name	= safeGet($comments,0);
		$this->room	= safeGet($comments,1);
		$this->workPhone= $this->_formatPhone(safeGet($comments,2));
		$this->homePhone= $this->_formatPhone(safeGet($comments,3));
		$this->other	= safeGet($comments,4);
		$this->login	= $fields[0];
		$this->uid	= $fields[2];
		$this->home	= $fields[5];
		$this->shell	= $fields[6];

		if($this->name == '&')
		{
			$this->name = ucwords($this->login);
		}

		$nofinger = $this->home .'/'. config('USER_NOFINGER');
		$this->hidden = file_exists($nofinger);

		// load over-rides
		$selfFile = $this->home .'/'. config('USER_BASE') . '/me' ;
		if(file_exists($selfFile))
		{
			$lines = file($selfFile);
			foreach($lines as $l)
			{
				list($k,$v) = explode("\t", $l, 2);
				$this->self[$k] = explode("\t", $v);
			}
		}
	}

	private function _formatPhone($f)
	{
		if(!$f) return;
		return "+$f";	// todo.  logic.
	}

	public function isHidden() { return $this->hidden; }
	public function getLogin() { return $this->login; }
	public function getName() { return $this->name; }
	public function getHome() { return $this->home; }
	public function getUID() { return $this->uid; }
	public function getShell() { return $this->shell; }
	public function getRoom() { return $this->room; }
	public function getWorkPhone() { return $this->workPhone; }
	public function getHomePhone() { return $this->homePhone; }
	public function getOther() { return $this->other; }

	public function getPlan()
	{
		if($this->plan === false)
		{
			$f =$this->home .'/'. config('USER_PLAN');
			$this->plan = (is_readable($f)?file_get_contents($f):'');
		}
		return $this->plan;
	}

	public function getProject()
	{
		if($this->project === false)
		{
			$f =$this->home .'/'. config('USER_PROJECT');
			$this->project = (is_readable($f)?file_get_contents($f):'');
		}
		return $this->project;
	}

	public function getPGPKey()
	{
		if($this->pgpkey === false)
		{
			$f =$this->home .'/'. config('USER_PGPKEY');
			$this->pgpkey = (is_readable($f)?file_get_contents($f):'');
		}
		return $this->pgpkey;
	}

	public function hasWeb()
	{
		return is_readable($this->home.'/'. config('WEB_DIR'));
	}
}

?>
