<?php

class UserStore
{
	static private $instance = false;
	private $users = array();
	function __construct()
	{
		$passwd = file(config('USER_LIST')) ;
		if($passwd) foreach($passwd as $line)
		{
			$groupStore = GroupStore::getInstance();
			$u = new Localuser($line);
			if($groupStore->isUserMember($u->getLogin(),config('GROUP')))
			{
				if(!$u->isHidden())
				{
					$this->users[$u->getLogin()] = $u;
				}
			}
		}

	}

	static public function getInstance()
	{
		if(!UserStore::$instance)
		{
			UserStore::$instance = new UserStore();
		}
		return UserStore::$instance;
	}

	public function getUser($name)
	{
		return safeGet($this->users, $name, false);
	}

	public function getUsers()
	{
		return $this->users;
	}

}

class GroupStore
{
	static private $instance = false;
	private $groups = array();
	function __construct()
	{
		$groups = file(config('GROUP_LIST')) ;
		if($groups) foreach($groups as $line)
		{
			$split = explode(':', $line);
			$name = $split[0];
			$users= explode(',', $split[3]);
			$this->groups[$name] = array();
			foreach($users as $u)
			{
				$this->groups[$name][$u] = true;
			}
		}

	}

	static public function getInstance()
	{
		if(!GroupStore::$instance)
		{
			GroupStore::$instance = new GroupStore();
		}
		return GroupStore::$instance;
	}

	public function isUserMember($user, $group)
	{
		$g = safeGet($this->groups,$group);
		if(!$g) return false;
		return safeGet($g, $user);
	}

	public function getMembers($group) { return $this->groups[$group]; }
}
?>
